using System;
using System.Collections.Generic;
using System.Text;
using Kaxaml.Properties;
using System.IO;

namespace Kaxaml.Documents
{
    class AgDocument : XamlDocument
    {

		#regionConstructors

        public AgDocument(string folder, string sourceText)
            : base(folder)
        {
            XamlDocumentType = XamlDocumentType.AgDocument;
            InitializeSourceText(sourceText);
        }

        public AgDocument(string folder)
            : base(folder)
        {
            XamlDocumentType = XamlDocumentType.AgDocument;
            InitializeSourceText(Settings.Default.AgDefaultXaml);
        }

		#endregionConstructors

		#regionStaticMethods

        public static AgDocument FromFile(string fullPath)
        {
            if (File.Exists(fullPath))
            {
                string sourceText = File.ReadAllText(fullPath);

                AgDocument document = new AgDocument(Path.GetDirectoryName(fullPath), sourceText);
                document.FullPath = fullPath;
                
                return document;
            }

            return null;
        }

		#endregionStaticMethods

    }
}